/**
 * Opt4J is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * Opt4J is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Opt4J. If not, see http://www.gnu.org/licenses/. 
 */

package org.opt4j.core;

import org.opt4j.core.problem.Creator;

import com.google.inject.Inject;
import com.google.inject.Provider;
import com.google.inject.Singleton;

/**
 * The {@link DefaultIndividualFactory} is a creator for standard
 * {@link Individual}s.
 * 
 * @author lukasiewycz, glass
 * 
 */
@Singleton
public class DefaultIndividualFactory extends AbstractIndividualFactory<Individual> {

	/**
	 * Constructs a {@link DefaultIndividualFactory} with a {@link Provider} for
	 * {@link Individual}s.
	 * 
	 * @param individualProvider
	 *            the provider that creates Individuals
	 * @param creator
	 *            the creator
	 */
	@SuppressWarnings({ "rawtypes" })
	@Inject
	public DefaultIndividualFactory(Provider<Individual> individualProvider, Creator creator) {
		super(individualProvider, creator);
	}

}
